# Gamerules
gamerule doImmediateRespawn false
gamerule spectatorsGenerateChunks true

# Revive
execute at @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}] run tag @p[distance=..2,gamemode=spectator] add Revive
execute at @a[tag=Revive] run kill @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}}},limit=1,distance=..5]
execute at @a[tag=Revive] run gamemode survival @p
execute at @a[tag=Revive] run effect give @p minecraft:slowness 60 2 true
execute at @a[tag=Revive] run effect give @p minecraft:weakness 60 2 true
execute at @a[tag=Revive] run effect give @p minecraft:glowing 60 2 true
execute at @a[tag=Revive] run effect give @p minecraft:hunger 60 2 true
execute at @a[tag=Revive] run effect give @p minecraft:mining_fatigue 60 2 true
execute at @a[tag=Revive] run effect give @p minecraft:poison 2 0 true
execute at @a[tag=Revive] run scoreboard players add @p Blood 1
execute at @a[tag=Revive] run scoreboard players set @p Minutes 4
execute at @a[tag=Revive] run scoreboard players set @p Seconds 59
execute at @a[tag=Revive] run scoreboard players set @p Lives 2
execute at @a[tag=Revive] run playsound minecraft:ui.toast.challenge_complete master @a ~ ~ ~ 10 1
execute at @a[tag=Revive] if dimension minecraft:overworld run spawnpoint @p
execute at @a[tag=Revive] if dimension minecraft:the_nether run spawnpoint @p

execute at @a[tag=Revive] run tag @p remove Revive

# Detect deaths
execute as @a[scores={deaths=1..}] run function hcrplus:death

# Check for Life Jam uses
execute as @a[scores={lifeReset=1..}] run function hcrplus:life_reset

# Set spawn
execute at @a[scores={health=0,Lives=..0}] if dimension minecraft:overworld run spawnpoint @p ~ ~1 ~
execute at @a[scores={health=0,Lives=..0}] if dimension minecraft:the_nether run spawnpoint @p ~ ~1 ~

# Ghost particles
execute at @a[gamemode=spectator] run particle dust{color:[1.000,1.000,1.000],scale:1} ~ ~1.5 ~ 0.5 0.5 0.5 0 2 force

# Scare
execute at @a[gamemode=spectator] run tag @e[type=!minecraft:player,distance=..0.8] add Scared
data modify entity @e[tag=Scared,limit=1,nbt=!{TicksFrozen:0}] TicksFrozen set value 140
effect give @e[tag=Scared,nbt=!{active_effects:[{id:"minecraft:wither"}]}] minecraft:wither 3 0 true

tag @e[type=!minecraft:player] remove Scared

# Possess
execute at @a[gamemode=spectator] run tag @a[distance=..1,gamemode=survival] add Possessed
effect give @a[tag=Possessed] minecraft:strength 1 0 true
effect give @a[tag=Possessed] minecraft:speed 1 0 true
effect give @a[tag=Possessed] minecraft:resistance 1 0 true
effect give @a[tag=Possessed] minecraft:glowing 1 0 true
tag @a remove Possessed

# Tick Timer
scoreboard players add @a Timer 1
execute as @a if score @s Timer matches 20.. run scoreboard players set @a Timer 0

# Cooldown Timer
execute as @a[scores={Blood=1..,Seconds=0..,Timer= 19..}] run scoreboard players remove @s Seconds 1
execute as @a[scores={Blood=1..,Minutes=1..,Seconds=..-1,Timer=19..}] run function hcrplus:minute_change
execute as @a[scores={Blood=1..,Minutes=0,Seconds=..-1,Timer=19..}] run function hcrplus:reset_cooldown
execute as @a[scores={Seconds=60..}] run function hcrplus:minute_overflow

# Display Timer
execute as @a[gamemode=!spectator,scores={Blood=1..}] run title @s actionbar ["",{"text":"Soul Charm Cooldown: ","color":"gray"},{"score":{"name":"@s","objective":"Minutes"}},{"text":"m "},{"score":{"name":"@s","objective":"Seconds"}},{"text":"s"}]

# Health Debuffs
execute at @a[scores={Blood=0}] run attribute @p[scores={Blood=0, Lives=2..3}] minecraft:generic.max_health base set 20
execute at @a[scores={Blood=1}] run attribute @p[scores={Blood=1, Lives=2..3}] minecraft:generic.max_health base set 10
execute at @a[scores={Blood=2}] run attribute @p[scores={Blood=2, Lives=2..3}] minecraft:generic.max_health base set 5
execute at @a[scores={Blood=3}] run attribute @p[scores={Blood=3, Lives=2..3}] minecraft:generic.max_health base set 2
execute at @a[scores={Blood=0}] run attribute @p[scores={Blood=0, Lives=4..}] minecraft:generic.max_health base set 24
execute at @a[scores={Blood=1}] run attribute @p[scores={Blood=1, Lives=4..}] minecraft:generic.max_health base set 12
execute at @a[scores={Blood=2}] run attribute @p[scores={Blood=2, Lives=4..}] minecraft:generic.max_health base set 6
execute at @a[scores={Blood=3}] run attribute @p[scores={Blood=3, Lives=4..}] minecraft:generic.max_health base set 4
execute at @a[scores={Blood=0}] run attribute @p[scores={Blood=0, Lives=1}] minecraft:generic.max_health base set 16
execute at @a[scores={Blood=1}] run attribute @p[scores={Blood=1, Lives=1}] minecraft:generic.max_health base set 8
execute at @a[scores={Blood=2}] run attribute @p[scores={Blood=2, Lives=1}] minecraft:generic.max_health base set 4
execute at @a[scores={Blood=3}] run attribute @p[scores={Blood=3, Lives=1}] minecraft:generic.max_health base set 2

# Potion buffs
execute as @a[scores={bedrockEssence=1}] run effect give @s resistance infinite 0 false
execute as @a[scores={axolotlBlesing=1}] run effect give @s regeneration infinite 0 false

# Fix scores
scoreboard players set @a[tag=!nHrCheck] Blood 0
scoreboard players set @a[tag=!nHrCheck] Seconds 0
scoreboard players set @a[tag=!nHrCheck] Minutes 0
scoreboard players set @a[tag=!nHrCheck] Lives 3
scoreboard players set @a[tag=!nHrCheck] bedrockEssence 0
scoreboard players set @a[tag=!nHrCheck] axolotlBlesing 0
scoreboard players set @a nothing 0

# Set team colors
team modify 1 color red
team modify 2 color yellow
team modify 3 color green
team modify 4 color aqua

# Set player teams
team leave @a[scores={Lives=0}]
team join 1 @a[scores={Lives=1}]
team join 2 @a[scores={Lives=2}]
team join 3 @a[scores={Lives=3}]
team join 4 @a[scores={Lives=4..}]

# Remove spectator cooldowns
execute as @a[gamemode=spectator] run scoreboard players set @s Seconds 0
execute as @a[gamemode=spectator] run scoreboard players set @s Minutes 0
execute as @a[gamemode=spectator] run scoreboard players set @s Blood 0

tag @a add nHrCheck
